# HG changeset patch
# User Petter Tomner <tomner@kth.se>
# Date 1637509798 -3600
#      Sun Nov 21 16:49:58 2021 +0100
# Node ID fa58b36eaffe1d2811c9a141a8b7168c60cd0e58
# Parent  1a3cd0f2e0963e2f733a0cd315d3b38fd4bfcd7d
interpreter: Use static instead of dynamic casts

Change dynamic_cast to static_cast by default in operators, using
macro DYNORSTAT_CAST, to speed up interpreter.

New flag in configure script "--enable-internal-checks", to enable
expensive but useful checks for verification or debugging. With the
flag, OCTAVE_ENABLE_INTERNAL_CHECKS is defined.

	* configure.ac: New flag "internal-checks"

libinterp/operators/
	* op-b-b.cc: Change dynamic_cast to DYNORSTAT_CAST
	* op-b-bm.cc: ... dito
	* op-b-sbm.cc
	* op-bm-b.cc
	* op-bm-bm.cc
	* op-bm-sbm.cc
	* op-cdm-cdm.cc
	* op-cell.cc
	* op-chm.cc
	* op-class.cc
	* op-cm-cm.cc
	* op-cm-cs.cc
	* op-cm-m.cc
	* op-cm-s.cc
	* op-cm-scm.cc
	* op-cm-sm.cc
	* op-cs-cm.cc
	* op-cs-cs.cc
	* op-cs-m.cc
	* op-cs-s.cc
	* op-cs-scm.cc
	* op-cs-sm.cc
	* op-dm-dm.cc
	* op-dm-scm.cc
	* op-dm-sm.cc
	* op-dm-template.cc
	* op-dms-template.cc
	* op-fcdm-fcdm.cc
	* op-fcm-fcm.cc
	* op-fcm-fcs.cc
	* op-fcm-fm.cc
	* op-fcm-fs.cc
	* op-fcn.cc
	* op-fcs-fcm.cc
	* op-fcs-fcs.cc
	* op-fcs-fm.cc
	* op-fcs-fs.cc
	* op-fdm-fdm.cc
	* op-fm-fcm.cc
	* op-fm-fcs.cc
	* op-fm-fm.cc
	* op-fm-fs.cc
	* op-fs-fcm.cc
	* op-fs-fcs.cc
	* op-fs-fm.cc
	* op-fs-fs.cc
	* op-int.h
	* op-m-cm.cc
	* op-m-cs.cc
	* op-m-m.cc
	* op-m-s.cc
	* op-m-scm.cc
	* op-m-sm.cc
	* op-mi.cc
	* op-pm-pm.cc
	* op-pm-scm.cc
	* op-pm-sm.cc
	* op-pm-template.cc
	* op-range.cc
	* op-s-cm.cc
	* op-s-cs.cc
	* op-s-m.cc
	* op-s-s.cc
	* op-s-scm.cc
	* op-s-sm.cc
	* op-sbm-b.cc
	* op-sbm-bm.cc
	* op-sbm-sbm.cc
	* op-scm-cm.cc
	* op-scm-cs.cc
	* op-scm-m.cc
	* op-scm-s.cc
	* op-scm-scm.cc
	* op-scm-sm.cc
	* op-sm-cm.cc
	* op-sm-cs.cc
	* op-sm-m.cc
	* op-sm-s.cc
	* op-sm-scm.cc
	* op-sm-sm.cc
	* op-str-m.cc
	* op-str-s.cc
	* op-str-str.cc
	* op-struct.cc
	* ops.h: Define DYNORSTAT_CAST

diff -r 1a3cd0f2e096 -r fa58b36eaffe configure.ac
--- a/configure.ac	Wed Dec 22 23:22:07 2021 +0100
+++ b/configure.ac	Sun Nov 21 16:49:58 2021 +0100
@@ -947,6 +947,20 @@
     [Define to 1 to truncate intermediate FP results.])
 fi
 
+### Enable internal checks
+
+## The checks slow down the execution and are redundant,
+## but useful for debugging or verifying GNU Octave.
+ENABLE_INTERNAL_CHECKS=no
+AC_ARG_ENABLE([internal-checks],
+  [AS_HELP_STRING([--enable-internal-checks],
+    [Enable internal checks that are redundant but useful to debug or verify GNU Octave])],
+  [if test "$enableval" = yes; then ENABLE_INTERNAL_CHECKS=yes; fi], [])
+if test $ENABLE_INTERNAL_CHECKS = yes; then
+  AC_DEFINE(OCTAVE_ENABLE_INTERNAL_CHECKS, 1,
+    [Define to 1 to enable internal checks.])
+fi
+
 ### Determine extra CFLAGS, CXXFLAGS that may be necessary for Octave.
 
 ## On Intel systems with gcc, we need to compile with -mieee-fp to get full
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-b-b.cc
--- a/libinterp/operators/op-b-b.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-b-b.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -65,14 +65,14 @@
 static octave_value
 oct_unop_uplus (const octave_base_value& a)
 {
-  const octave_bool& v = dynamic_cast<const octave_bool&> (a);
+  const octave_bool& v = DYNORSTAT_CAST<const octave_bool&> (a);
   return octave_value (v.double_value ());
 }
 
 static octave_value
 oct_unop_uminus (const octave_base_value& a)
 {
-  const octave_bool& v = dynamic_cast<const octave_bool&> (a);
+  const octave_bool& v = DYNORSTAT_CAST<const octave_bool&> (a);
   return octave_value (- v.double_value ());
 }
 
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-b-bm.cc
--- a/libinterp/operators/op-b-bm.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-b-bm.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -61,7 +61,7 @@
 
 DEFCONV (bool_matrix_conv, bool, bool_matrix)
 {
-  const octave_bool& v = dynamic_cast<const octave_bool&> (a);
+  const octave_bool& v = DYNORSTAT_CAST<const octave_bool&> (a);
 
   return new octave_bool_matrix (v.bool_matrix_value ());
 }
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-b-sbm.cc
--- a/libinterp/operators/op-b-sbm.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-b-sbm.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -51,9 +51,9 @@
 
 DEFCATOP (b_sbm, bool, sparse_bool_matrix)
 {
-  const octave_bool& v1 = dynamic_cast<const octave_bool&> (a1);
+  const octave_bool& v1 = DYNORSTAT_CAST<const octave_bool&> (a1);
   const octave_sparse_bool_matrix& v2
-    = dynamic_cast<const octave_sparse_bool_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_sparse_bool_matrix&> (a2);
   SparseBoolMatrix tmp (1, 1, v1.bool_value ());
   return octave_value (tmp. concat (v2.sparse_bool_matrix_value (),
                                     ra_idx));
@@ -61,24 +61,24 @@
 
 DEFCATOP (b_sm, bool, sparse_matrix)
 {
-  const octave_bool& v1 = dynamic_cast<const octave_bool&> (a1);
-  const octave_sparse_matrix& v2 = dynamic_cast<const octave_sparse_matrix&> (a2);
+  const octave_bool& v1 = DYNORSTAT_CAST<const octave_bool&> (a1);
+  const octave_sparse_matrix& v2 = DYNORSTAT_CAST<const octave_sparse_matrix&> (a2);
   SparseMatrix tmp (1, 1, v1.scalar_value ());
   return octave_value (tmp. concat (v2.sparse_matrix_value (), ra_idx));
 }
 
 DEFCATOP (s_sbm, scalar, sparse_bool_matrix)
 {
-  const octave_scalar& v1 = dynamic_cast<const octave_scalar&> (a1);
+  const octave_scalar& v1 = DYNORSTAT_CAST<const octave_scalar&> (a1);
   const octave_sparse_bool_matrix& v2
-    = dynamic_cast<const octave_sparse_bool_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_sparse_bool_matrix&> (a2);
   SparseMatrix tmp (1, 1, v1.scalar_value ());
   return octave_value(tmp. concat (v2.sparse_matrix_value (), ra_idx));
 }
 
 DEFCONV (sparse_bool_matrix_conv, bool, sparse_bool_matrix)
 {
-  const octave_bool& v = dynamic_cast<const octave_bool&> (a);
+  const octave_bool& v = DYNORSTAT_CAST<const octave_bool&> (a);
 
   return new octave_sparse_bool_matrix
     (SparseBoolMatrix (1, 1, v.bool_value ()));
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-bm-b.cc
--- a/libinterp/operators/op-bm-b.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-bm-b.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -74,7 +74,7 @@
                               const octave_value_list& idx,
                               const octave_base_value& a2)
 {
-  octave_bool_matrix& v1 = dynamic_cast<octave_bool_matrix&> (a1);
+  octave_bool_matrix& v1 = DYNORSTAT_CAST<octave_bool_matrix&> (a1);
 
   // FIXME: perhaps add a warning for this conversion
   //        if the values are not all 0 or 1?
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-bm-bm.cc
--- a/libinterp/operators/op-bm-bm.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-bm-bm.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -63,7 +63,7 @@
 
 DEFUNOP (transpose, bool_matrix)
 {
-  const octave_bool_matrix& v = dynamic_cast<const octave_bool_matrix&> (a);
+  const octave_bool_matrix& v = DYNORSTAT_CAST<const octave_bool_matrix&> (a);
 
   if (v.ndims () > 2)
     error ("transpose not defined for N-D objects");
@@ -115,7 +115,7 @@
                               const octave_value_list& idx,
                               const octave_base_value& a2)
 {
-  octave_bool_matrix& v1 = dynamic_cast<octave_bool_matrix&> (a1);
+  octave_bool_matrix& v1 = DYNORSTAT_CAST<octave_bool_matrix&> (a1);
 
   // FIXME: perhaps add a warning for this conversion
   //        if the values are not all 0 or 1?
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-bm-sbm.cc
--- a/libinterp/operators/op-bm-sbm.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-bm-sbm.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -53,9 +53,9 @@
 
 DEFCATOP (bm_sbm, bool_matrix, sparse_bool_matrix)
 {
-  const octave_bool_matrix& v1 = dynamic_cast<const octave_bool_matrix&> (a1);
+  const octave_bool_matrix& v1 = DYNORSTAT_CAST<const octave_bool_matrix&> (a1);
   const octave_sparse_bool_matrix& v2
-    = dynamic_cast<const octave_sparse_bool_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_sparse_bool_matrix&> (a2);
   SparseBoolMatrix tmp (v1.bool_matrix_value ());
   return octave_value (tmp. concat (v2.sparse_bool_matrix_value (),
                                     ra_idx));
@@ -63,24 +63,24 @@
 
 DEFCATOP (m_sbm, matrix, sparse_bool_matrix)
 {
-  const octave_matrix& v1 = dynamic_cast<const octave_matrix&> (a1);
+  const octave_matrix& v1 = DYNORSTAT_CAST<const octave_matrix&> (a1);
   const octave_sparse_bool_matrix& v2
-    = dynamic_cast<const octave_sparse_bool_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_sparse_bool_matrix&> (a2);
   SparseMatrix tmp (v1.matrix_value ());
   return octave_value (tmp. concat (v2.sparse_matrix_value (), ra_idx));
 }
 
 DEFCATOP (bm_sm, bool_matrix, sparse_matrix)
 {
-  const octave_bool_matrix& v1 = dynamic_cast<const octave_bool_matrix&> (a1);
-  const octave_sparse_matrix& v2 = dynamic_cast<const octave_sparse_matrix&> (a2);
+  const octave_bool_matrix& v1 = DYNORSTAT_CAST<const octave_bool_matrix&> (a1);
+  const octave_sparse_matrix& v2 = DYNORSTAT_CAST<const octave_sparse_matrix&> (a2);
   SparseMatrix tmp (v1.matrix_value ());
   return octave_value (tmp. concat (v2.sparse_matrix_value (), ra_idx));
 }
 
 DEFCONV (sparse_bool_matrix_conv, bool_matrix, sparse_bool_matrix)
 {
-  const octave_bool_matrix& v = dynamic_cast<const octave_bool_matrix&> (a);
+  const octave_bool_matrix& v = DYNORSTAT_CAST<const octave_bool_matrix&> (a);
   return new octave_sparse_bool_matrix
     (SparseBoolMatrix (v.bool_matrix_value ()));
 }
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-cdm-cdm.cc
--- a/libinterp/operators/op-cdm-cdm.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-cdm-cdm.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -48,14 +48,14 @@
 DEFUNOP (transpose, complex_diag_matrix)
 {
   const octave_complex_diag_matrix& v
-    = dynamic_cast<const octave_complex_diag_matrix&> (a);
+    = DYNORSTAT_CAST<const octave_complex_diag_matrix&> (a);
   return octave_value (v.complex_diag_matrix_value ().transpose ());
 }
 
 DEFUNOP (hermitian, complex_diag_matrix)
 {
   const octave_complex_diag_matrix& v
-    = dynamic_cast<const octave_complex_diag_matrix&> (a);
+    = DYNORSTAT_CAST<const octave_complex_diag_matrix&> (a);
   return octave_value (v.complex_diag_matrix_value ().hermitian ());
 }
 
@@ -68,9 +68,9 @@
 DEFBINOP (div, complex_diag_matrix, complex_diag_matrix)
 {
   const octave_complex_diag_matrix& v1
-    = dynamic_cast<const octave_complex_diag_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_complex_diag_matrix&> (a1);
   const octave_complex_diag_matrix& v2
-    = dynamic_cast<const octave_complex_diag_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_complex_diag_matrix&> (a2);
 
   return xdiv (v1.complex_diag_matrix_value (),
                v2.complex_diag_matrix_value ());
@@ -79,9 +79,9 @@
 DEFBINOP (ldiv, complex_diag_matrix, complex_diag_matrix)
 {
   const octave_complex_diag_matrix& v1
-    = dynamic_cast<const octave_complex_diag_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_complex_diag_matrix&> (a1);
   const octave_complex_diag_matrix& v2
-    = dynamic_cast<const octave_complex_diag_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_complex_diag_matrix&> (a2);
 
   return xleftdiv (v1.complex_diag_matrix_value (),
                    v2.complex_diag_matrix_value ());
@@ -90,7 +90,7 @@
 CONVDECL (complex_diag_matrix_to_complex_matrix)
 {
   const octave_complex_diag_matrix& v
-    = dynamic_cast<const octave_complex_diag_matrix&> (a);
+    = DYNORSTAT_CAST<const octave_complex_diag_matrix&> (a);
 
   return new octave_complex_matrix (v.complex_matrix_value ());
 }
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-cell.cc
--- a/libinterp/operators/op-cell.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-cell.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -43,7 +43,7 @@
 
 DEFUNOP (transpose, cell)
 {
-  const octave_cell& v = dynamic_cast<const octave_cell&> (a);
+  const octave_cell& v = DYNORSTAT_CAST<const octave_cell&> (a);
 
   if (v.ndims () > 2)
     error ("transpose not defined for N-D objects");
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-chm.cc
--- a/libinterp/operators/op-chm.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-chm.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -44,7 +44,7 @@
 
 DEFUNOP (transpose, char_matrix)
 {
-  const octave_char_matrix& v = dynamic_cast<const octave_char_matrix&> (a);
+  const octave_char_matrix& v = DYNORSTAT_CAST<const octave_char_matrix&> (a);
 
   return octave_value (v.matrix_value ().transpose ());
 }
@@ -54,8 +54,8 @@
 
 DEFCATOP (chm_s, char_matrix, scalar)
 {
-  const octave_char_matrix& v1 = dynamic_cast<const octave_char_matrix&> (a1);
-  const octave_scalar& v2 = dynamic_cast<const octave_scalar&> (a2);
+  const octave_char_matrix& v1 = DYNORSTAT_CAST<const octave_char_matrix&> (a1);
+  const octave_scalar& v2 = DYNORSTAT_CAST<const octave_scalar&> (a2);
 
   warn_implicit_conversion ("Octave:num-to-str",
                             v2.type_name (), v1.type_name ());
@@ -66,8 +66,8 @@
 
 DEFCATOP (chm_m, char_matrix, matrix)
 {
-  const octave_char_matrix& v1 = dynamic_cast<const octave_char_matrix&> (a1);
-  const octave_matrix& v2 = dynamic_cast<const octave_matrix&> (a2);
+  const octave_char_matrix& v1 = DYNORSTAT_CAST<const octave_char_matrix&> (a1);
+  const octave_matrix& v2 = DYNORSTAT_CAST<const octave_matrix&> (a2);
 
   warn_implicit_conversion ("Octave:num-to-str",
                             v2.type_name (), v1.type_name ());
@@ -78,8 +78,8 @@
 
 DEFCATOP (s_chm, scalar, char_matrix)
 {
-  const octave_scalar& v1 = dynamic_cast<const octave_scalar&> (a1);
-  const octave_char_matrix& v2 = dynamic_cast<const octave_char_matrix&> (a2);
+  const octave_scalar& v1 = DYNORSTAT_CAST<const octave_scalar&> (a1);
+  const octave_char_matrix& v2 = DYNORSTAT_CAST<const octave_char_matrix&> (a2);
 
   warn_implicit_conversion ("Octave:num-to-str",
                             v1.type_name (), v2.type_name ());
@@ -90,8 +90,8 @@
 
 DEFCATOP (m_chm, matrix, char_matrix)
 {
-  const octave_matrix& v1 = dynamic_cast<const octave_matrix&> (a1);
-  const octave_char_matrix& v2 = dynamic_cast<const octave_char_matrix&> (a2);
+  const octave_matrix& v1 = DYNORSTAT_CAST<const octave_matrix&> (a1);
+  const octave_char_matrix& v2 = DYNORSTAT_CAST<const octave_char_matrix&> (a2);
 
   warn_implicit_conversion ("Octave:num-to-str",
                             v1.type_name (), v2.type_name ());
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-class.cc
--- a/libinterp/operators/op-class.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-class.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -92,7 +92,7 @@
       else
         {
           const octave_class& v
-            = dynamic_cast<const octave_class&> (a.get_rep ());
+            = DYNORSTAT_CAST<const octave_class&> (a.get_rep ());
 
           return octave_value (v.map_value ().transpose (),
                                v.class_name (),
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-cm-cm.cc
--- a/libinterp/operators/op-cm-cm.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-cm-cm.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -49,7 +49,7 @@
 DEFUNOP (transpose, complex_matrix)
 {
   const octave_complex_matrix& v
-    = dynamic_cast<const octave_complex_matrix&> (a);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a);
 
   if (v.ndims () > 2)
     error ("transpose not defined for N-D objects");
@@ -60,7 +60,7 @@
 DEFUNOP (hermitian, complex_matrix)
 {
   const octave_complex_matrix& v
-    = dynamic_cast<const octave_complex_matrix&> (a);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a);
 
   if (v.ndims () > 2)
     error ("complex-conjugate transpose not defined for N-D objects");
@@ -84,9 +84,9 @@
 DEFBINOP (div, complex_matrix, complex_matrix)
 {
   const octave_complex_matrix& v1
-    = dynamic_cast<const octave_complex_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a1);
   const octave_complex_matrix& v2
-    = dynamic_cast<const octave_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a2);
   MatrixType typ = v2.matrix_type ();
 
   ComplexMatrix ret = xdiv (v1.complex_matrix_value (),
@@ -104,9 +104,9 @@
 DEFBINOP (ldiv, complex_matrix, complex_matrix)
 {
   const octave_complex_matrix& v1
-    = dynamic_cast<const octave_complex_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a1);
   const octave_complex_matrix& v2
-    = dynamic_cast<const octave_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a2);
   MatrixType typ = v1.matrix_type ();
 
   ComplexMatrix ret = xleftdiv (v1.complex_matrix_value (),
@@ -119,9 +119,9 @@
 DEFBINOP (trans_mul, complex_matrix, complex_matrix)
 {
   const octave_complex_matrix& v1
-    = dynamic_cast<const octave_complex_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a1);
   const octave_complex_matrix& v2
-    = dynamic_cast<const octave_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a2);
   return octave_value(xgemm (v1.complex_matrix_value (),
                              v2.complex_matrix_value (),
                              blas_trans, blas_no_trans));
@@ -130,9 +130,9 @@
 DEFBINOP (mul_trans, complex_matrix, complex_matrix)
 {
   const octave_complex_matrix& v1
-    = dynamic_cast<const octave_complex_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a1);
   const octave_complex_matrix& v2
-    = dynamic_cast<const octave_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a2);
   return octave_value(xgemm (v1.complex_matrix_value (),
                              v2.complex_matrix_value (),
                              blas_no_trans, blas_trans));
@@ -141,9 +141,9 @@
 DEFBINOP (herm_mul, complex_matrix, complex_matrix)
 {
   const octave_complex_matrix& v1
-    = dynamic_cast<const octave_complex_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a1);
   const octave_complex_matrix& v2
-    = dynamic_cast<const octave_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a2);
   return octave_value(xgemm (v1.complex_matrix_value (),
                              v2.complex_matrix_value (),
                              blas_conj_trans, blas_no_trans));
@@ -152,9 +152,9 @@
 DEFBINOP (mul_herm, complex_matrix, complex_matrix)
 {
   const octave_complex_matrix& v1
-    = dynamic_cast<const octave_complex_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a1);
   const octave_complex_matrix& v2
-    = dynamic_cast<const octave_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a2);
   return octave_value(xgemm (v1.complex_matrix_value (),
                              v2.complex_matrix_value (),
                              blas_no_trans, blas_conj_trans));
@@ -163,9 +163,9 @@
 DEFBINOP (trans_ldiv, complex_matrix, complex_matrix)
 {
   const octave_complex_matrix& v1
-    = dynamic_cast<const octave_complex_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a1);
   const octave_complex_matrix& v2
-    = dynamic_cast<const octave_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a2);
   MatrixType typ = v1.matrix_type ();
 
   ComplexMatrix ret = xleftdiv (v1.complex_matrix_value (),
@@ -178,9 +178,9 @@
 DEFBINOP (herm_ldiv, complex_matrix, complex_matrix)
 {
   const octave_complex_matrix& v1
-    = dynamic_cast<const octave_complex_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a1);
   const octave_complex_matrix& v2
-    = dynamic_cast<const octave_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a2);
   MatrixType typ = v1.matrix_type ();
 
   ComplexMatrix ret = xleftdiv (v1.complex_matrix_value (),
@@ -214,9 +214,9 @@
 DEFBINOP (el_ldiv, complex_matrix, complex_matrix)
 {
   const octave_complex_matrix& v1
-    = dynamic_cast<const octave_complex_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a1);
   const octave_complex_matrix& v2
-    = dynamic_cast<const octave_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a2);
 
   return octave_value (quotient (v2.complex_array_value (),
                                  v1.complex_array_value ()));
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-cm-cs.cc
--- a/libinterp/operators/op-cm-cs.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-cm-cs.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -48,8 +48,8 @@
 DEFBINOP (div, complex_matrix, complex)
 {
   const octave_complex_matrix& v1
-    = dynamic_cast<const octave_complex_matrix&> (a1);
-  const octave_complex& v2 = dynamic_cast<const octave_complex&> (a2);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a1);
+  const octave_complex& v2 = DYNORSTAT_CAST<const octave_complex&> (a2);
 
   return octave_value (v1.complex_array_value () / v2.complex_value ());
 }
@@ -59,8 +59,8 @@
 DEFBINOP (ldiv, complex_matrix, complex)
 {
   const octave_complex_matrix& v1
-    = dynamic_cast<const octave_complex_matrix&> (a1);
-  const octave_complex& v2 = dynamic_cast<const octave_complex&> (a2);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a1);
+  const octave_complex& v2 = DYNORSTAT_CAST<const octave_complex&> (a2);
 
   ComplexMatrix m1 = v1.complex_matrix_value ();
   ComplexMatrix m2 = v2.complex_matrix_value ();
@@ -89,8 +89,8 @@
 DEFBINOP (el_div, complex_matrix, complex)
 {
   const octave_complex_matrix& v1
-    = dynamic_cast<const octave_complex_matrix&> (a1);
-  const octave_complex& v2 = dynamic_cast<const octave_complex&> (a2);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a1);
+  const octave_complex& v2 = DYNORSTAT_CAST<const octave_complex&> (a2);
 
   return octave_value (v1.complex_array_value () / v2.complex_value ());
 }
@@ -101,8 +101,8 @@
 DEFBINOP (el_ldiv, complex_matrix, complex)
 {
   const octave_complex_matrix& v1
-    = dynamic_cast<const octave_complex_matrix&> (a1);
-  const octave_complex& v2 = dynamic_cast<const octave_complex&> (a2);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a1);
+  const octave_complex& v2 = DYNORSTAT_CAST<const octave_complex&> (a2);
 
   return elem_xdiv (v2.complex_value (), v1.complex_array_value ());
 }
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-cm-m.cc
--- a/libinterp/operators/op-cm-m.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-cm-m.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -54,8 +54,8 @@
 DEFBINOP (mul_trans, complex_matrix, matrix)
 {
   const octave_complex_matrix& v1
-    = dynamic_cast<const octave_complex_matrix&> (a1);
-  const octave_matrix& v2 = dynamic_cast<const octave_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a1);
+  const octave_matrix& v2 = DYNORSTAT_CAST<const octave_matrix&> (a2);
 
   ComplexMatrix m1 = v1.complex_matrix_value ();
   Matrix m2 = v2.matrix_value ();
@@ -67,8 +67,8 @@
 DEFBINOP (div, complex_matrix, matrix)
 {
   const octave_complex_matrix& v1
-    = dynamic_cast<const octave_complex_matrix&> (a1);
-  const octave_matrix& v2 = dynamic_cast<const octave_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a1);
+  const octave_matrix& v2 = DYNORSTAT_CAST<const octave_matrix&> (a2);
   MatrixType typ = v2.matrix_type ();
 
   ComplexMatrix ret = xdiv (v1.complex_matrix_value (),
@@ -86,8 +86,8 @@
 DEFBINOP (ldiv, complex_matrix, matrix)
 {
   const octave_complex_matrix& v1
-    = dynamic_cast<const octave_complex_matrix&> (a1);
-  const octave_matrix& v2 = dynamic_cast<const octave_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a1);
+  const octave_matrix& v2 = DYNORSTAT_CAST<const octave_matrix&> (a2);
   MatrixType typ = v1.matrix_type ();
 
   ComplexMatrix ret = xleftdiv (v1.complex_matrix_value (),
@@ -111,8 +111,8 @@
 DEFBINOP (el_ldiv, complex_matrix, matrix)
 {
   const octave_complex_matrix& v1
-    = dynamic_cast<const octave_complex_matrix&> (a1);
-  const octave_matrix& v2 = dynamic_cast<const octave_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a1);
+  const octave_matrix& v2 = DYNORSTAT_CAST<const octave_matrix&> (a2);
 
   return quotient (v2.array_value (), v1.complex_array_value ());
 }
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-cm-s.cc
--- a/libinterp/operators/op-cm-s.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-cm-s.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -51,8 +51,8 @@
 DEFBINOP (div, complex_matrix, scalar)
 {
   const octave_complex_matrix& v1
-    = dynamic_cast<const octave_complex_matrix&> (a1);
-  const octave_scalar& v2 = dynamic_cast<const octave_scalar&> (a2);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a1);
+  const octave_scalar& v2 = DYNORSTAT_CAST<const octave_scalar&> (a2);
 
   return octave_value (v1.complex_array_value () / v2.double_value ());
 }
@@ -62,8 +62,8 @@
 DEFBINOP (ldiv, complex_matrix, scalar)
 {
   const octave_complex_matrix& v1
-    = dynamic_cast<const octave_complex_matrix&> (a1);
-  const octave_scalar& v2 = dynamic_cast<const octave_scalar&> (a2);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a1);
+  const octave_scalar& v2 = DYNORSTAT_CAST<const octave_scalar&> (a2);
 
   ComplexMatrix m1 = v1.complex_matrix_value ();
   Matrix m2 = v2.matrix_value ();
@@ -87,8 +87,8 @@
 DEFBINOP (el_div, complex_matrix, scalar)
 {
   const octave_complex_matrix& v1
-    = dynamic_cast<const octave_complex_matrix&> (a1);
-  const octave_scalar& v2 = dynamic_cast<const octave_scalar&> (a2);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a1);
+  const octave_scalar& v2 = DYNORSTAT_CAST<const octave_scalar&> (a2);
 
   return octave_value (v1.complex_array_value () / v2.double_value ());
 }
@@ -98,8 +98,8 @@
 DEFBINOP (el_ldiv, complex_matrix, scalar)
 {
   const octave_complex_matrix& v1
-    = dynamic_cast<const octave_complex_matrix&> (a1);
-  const octave_scalar& v2 = dynamic_cast<const octave_scalar&> (a2);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a1);
+  const octave_scalar& v2 = DYNORSTAT_CAST<const octave_scalar&> (a2);
 
   return elem_xdiv (v2.double_value (), v1.complex_array_value ());
 }
diff -r 1a3cd0f2e096 -r fa58b36eaffe libinterp/operators/op-cm-scm.cc
--- a/libinterp/operators/op-cm-scm.cc	Wed Dec 22 23:22:07 2021 +0100
+++ b/libinterp/operators/op-cm-scm.cc	Sun Nov 21 16:49:58 2021 +0100
@@ -52,9 +52,9 @@
 DEFBINOP (div, complex_matrix, sparse_complex_matrix)
 {
   const octave_complex_matrix& v1
-    = dynamic_cast<const octave_complex_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a1);
   const octave_sparse_complex_matrix& v2
-    = dynamic_cast<const octave_sparse_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_sparse_complex_matrix&> (a2);
 
   if (v2.rows () == 1 && v2.columns () == 1)
     return octave_value (v1.complex_array_value () / v2.complex_value ());
@@ -78,9 +78,9 @@
 DEFBINOP (ldiv, complex_matrix, sparse_complex_matrix)
 {
   const octave_complex_matrix& v1
-    = dynamic_cast<const octave_complex_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a1);
   const octave_sparse_complex_matrix& v2
-    = dynamic_cast<const octave_sparse_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_sparse_complex_matrix&> (a2);
   MatrixType typ = v1.matrix_type ();
 
   ComplexMatrix ret = xleftdiv (v1.complex_matrix_value (),
@@ -106,9 +106,9 @@
 DEFBINOP (el_pow, complex_matrix, sparse_complex_matrix)
 {
   const octave_complex_matrix& v1
-    = dynamic_cast<const octave_complex_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a1);
   const octave_sparse_complex_matrix& v2
-    = dynamic_cast<const octave_sparse_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_sparse_complex_matrix&> (a2);
 
   return octave_value
          (elem_xpow (SparseComplexMatrix (v1.complex_matrix_value ()),
@@ -118,9 +118,9 @@
 DEFBINOP (el_ldiv, sparse_complex_matrix, matrix)
 {
   const octave_complex_matrix& v1
-    = dynamic_cast<const octave_complex_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a1);
   const octave_sparse_complex_matrix& v2
-    = dynamic_cast<const octave_sparse_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_sparse_complex_matrix&> (a2);
 
   return octave_value (quotient (v2.sparse_complex_matrix_value (),
                                  v1.complex_matrix_value ()));
@@ -132,9 +132,9 @@
 DEFCATOP (cm_scm, complex_matrix, sparse_complex_matrix)
 {
   const octave_complex_matrix& v1
-    = dynamic_cast<const octave_complex_matrix&> (a1);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a1);
   const octave_sparse_complex_matrix& v2
-    = dynamic_cast<const octave_sparse_complex_matrix&> (a2);
+    = DYNORSTAT_CAST<const octave_sparse_complex_matrix&> (a2);
   SparseComplexMatrix tmp (v1.complex_matrix_value ());
   return octave_value (tmp. concat (v2.sparse_complex_matrix_value (),
                                     ra_idx));
@@ -144,7 +144,7 @@
          sparse_complex_matrix)
 {
   const octave_complex_matrix& v
-    = dynamic_cast<const octave_complex_matrix&> (a);
+    = DYNORSTAT_CAST<const octave_complex_matrix&> (a);
   return new octave_sparse_complex_matrix
          (SparseComplexMatrix (v.complex_matrix_value ()));
 }
